#!/bin/sh


test -e /userdisk/stop.sh && /userdisk/stop.sh
sleep 1
cp /userdisk/led_mp /tmp/
/tmp/led_mp --STATE_BLINK 1
/tmp/led_mp --STATE_BLINK 2
sleep 1

mkdir -p /usr/share/fwrecovery
rm -rf /usr/share/fwrecovery/fwrecovery.tar.gz
tar -zc -f /usr/share/fwrecovery/fwrecovery.tar.gz /userdisk
sync
sleep 1

echo "========== Firmware Update Start ==========" | tee /usr/share/fwrecovery/fwupgrade.log

echo "---- Step 1: Backup setting file. ----" | tee -a /usr/share/fwrecovery/fwupgrade.log
/tmp/led_mp --CH01 1
sleep 1
test -e /userdisk/sys_config.ini && cp -rf /userdisk/sys_config.ini /tmp/MxNVR_fwupg
test -e /userdisk/syslog.dat && cp -rf /userdisk/syslog.dat /tmp/MxNVR_fwupg
test -e /userdisk/syslog.dat.1 && cp -rf /userdisk/syslog.dat.1 /tmp/MxNVR_fwupg
test -e /userdisk/nvrsch.db && cp -rf /userdisk/nvrsch.db /tmp/MxNVR_fwupg

echo "---- Step 2: Cleanup disk. ----" | tee -a /usr/share/fwrecovery/fwupgrade.log
/tmp/led_mp --CH02 1
sleep 1
test -n "$(mount -l | grep '/mnt/.HDD1' | cut -d ' ' -f 1)" && mount -l | grep '/mnt/.HDD1' | cut -d ' ' -f 1 | xargs umount -f 
test -n "$(mount -l | grep '/mnt/HDD1' | cut -d ' ' -f 1)" && mount -l | grep '/mnt/HDD1' | cut -d ' ' -f 1 | xargs umount -f 
test -n "$(mount -l | grep '/mnt/.HDD2' | cut -d ' ' -f 1)" && mount -l | grep '/mnt/.HDD2' | cut -d ' ' -f 1 | xargs umount -f 
test -n "$(mount -l | grep '/mnt/HDD2' | cut -d ' ' -f 1)" && mount -l | grep '/mnt/HDD2' | cut -d ' ' -f 1 | xargs umount -f 
rm -rf /mnt/.HDD1*
rm -rf /mnt/HDD1*
rm -rf /mnt/.HDD2*
rm -rf /mnt/HDD2*
test -n "$(mount -l | grep '/mnt/sata0' | cut -d ' ' -f 1)" && mount -l | grep '/mnt/sata0' | cut -d ' ' -f 1 | xargs umount -f 
test -n "$(mount -l | grep '/mnt/sata1' | cut -d ' ' -f 1)" && mount -l | grep '/mnt/sata1' | cut -d ' ' -f 1 | xargs umount -f 
test -n "$(mount -l | grep '/mnt/usb0' | cut -d ' ' -f 1)" && mount -l | grep '/mnt/usb0' | cut -d ' ' -f 1 | xargs umount -f 
rm -rf /mnt/sata0
rm -rf /mnt/sata1
rm -rf /mnt/usb0
test -e /tmp/MxNVR_fwupg/Upgrade_Firmware.tar.gz && rm -rf /userdisk/* || exit 1

echo "---- Step 3: Update userdisk. ----" | tee -a /usr/share/fwrecovery/fwupgrade.log
/tmp/led_mp --CH03 1
sleep 1
tar -zx -f /tmp/MxNVR_fwupg/Upgrade_Firmware.tar.gz -C / || exit 1
chown -hR root:root /userdisk
chmod -R 777 /userdisk

echo "---- Step 4: Update root disk. ----" | tee -a /usr/share/fwrecovery/fwupgrade.log
/tmp/led_mp --CH04 1
sleep 1
cp -rf /userdisk/filesystem_root/* /

echo "---- Step 5: Restore setting file. ----" | tee -a /usr/share/fwrecovery/fwupgrade.log
/tmp/led_mp --CH05 1
sleep 1
test -e /tmp/MxNVR_fwupg/sys_config.ini && cp -rf /tmp/MxNVR_fwupg/sys_config.ini /userdisk
test -e /tmp/MxNVR_fwupg/syslog.dat && cp -rf /tmp/MxNVR_fwupg/syslog.dat /userdisk
test -e /tmp/MxNVR_fwupg/syslog.dat.1 && cp -rf /tmp/MxNVR_fwupg/syslog.dat.1 /userdisk
test -e /tmp/MxNVR_fwupg/nvrsch.db && cp -rf /tmp/MxNVR_fwupg/nvrsch.db /userdisk

echo "---- Step 6: Add workaround & patch. ----" | tee -a /usr/share/fwrecovery/fwupgrade.log
/tmp/led_mp --CH06 1
sleep 1
test -z "$(cat /etc/default/rcS | grep 'HWCLOCKPARS=--directisa')" && echo "HWCLOCKPARS=--directisa" >> /etc/default/rcS

echo "---- Step 7: Remove temp file. ----" | tee -a /usr/share/fwrecovery/fwupgrade.log
/tmp/led_mp --CH07 1
sleep 1
rm -rf /tmp/MxNVR_fwupg

echo "---- Step 8: Additional operation. ----" | tee -a /usr/share/fwrecovery/fwupgrade.log
/tmp/led_mp --CH08 1
sleep 1
/bin/touch /forcefsck
update-rc.d -f exim4 remove
apt-get remove ntpdata
echo "Re-build database."
/tmp/led_mp --STORAGE_BLINK 1
/tmp/led_mp --STORAGE_BLINK 2
test -e /dev/disk/by-path/pci-0000:00:1f.2-scsi-0:0:0:0-part1 && mount /dev/sda1 /mnt/.HDD1_TMP
test -e /dev/disk/by-path/pci-0000:00:1f.2-scsi-0:0:0:0-part2 && mount /dev/sda2 /mnt/.HDD1_DB
test -e /dev/disk/by-path/pci-0000:00:1f.2-scsi-0:0:0:0-part3 && mount /dev/sda3 /mnt/HDD1
test -e /dev/disk/by-path/pci-0000:00:1f.2-scsi-0:0:1:0-part1 && mount /dev/sdb1 /mnt/.HDD2_TMP
test -e /dev/disk/by-path/pci-0000:00:1f.2-scsi-0:0:1:0-part2 && mount /dev/sdb2 /mnt/.HDD2_DB
test -e /dev/disk/by-path/pci-0000:00:1f.2-scsi-0:0:1:0-part3 && mount /dev/sdb3 /mnt/HDD2
s=0
test -z "$(mount | grep '/mnt/USB')" && s=0 || s=1
if [ -L "/dev/disk/by-path/pci-0000:00:1d.7-usb-0:2:1.0-scsi-0:0:0:0-part1" ] ; then 
	if [ "$s" == "0" ] ; then 
		dev=$(ls -l /dev/disk/by-path/pci-0000\:00\:1d.7-usb-0\:2\:1.0-scsi-0\:0\:0\:0-part1 | sed 's/^.*-> //g' | sed 's/\.\.\/\.\./\/dev/g')
		echo "!!USB device has be inserted on ($dev)!!"
		mkdir -p /mnt/USB
		mount $dev /mnt/USB
		mount | grep '/mnt/USB'
		s=1
	fi
	test -n "$(mount -l | grep '/mnt/HDD1' | cut -d ' ' -f 1)" && /userdisk/chkdb -e -r 2 /mnt/USB/hdd1 -v 1 -d 1 -s 90MB -c 1000 -l /mnt/log/chkdb_hdd1.log
	test -n "$(mount -l | grep '/mnt/HDD2' | cut -d ' ' -f 1)" && /userdisk/chkdb -e -r 2 /mnt/USB/hdd2 -v 1 -d 2 -s 90MB -c 1000 -l /mnt/log/chkdb_hdd2.log
else
	if [ "$s" != "0" ] ; then 
		echo "!!USB device has be removed!!"
		umount /mnt/USB
		s=0
	fi
	test -n "$(mount -l | grep '/mnt/HDD1' | cut -d ' ' -f 1)" && /userdisk/chkdb -e -r -v 1 -d 1 -s 90MB -c 1000 -l /mnt/log/chkdb_hdd1.log
	test -n "$(mount -l | grep '/mnt/HDD2' | cut -d ' ' -f 1)" && /userdisk/chkdb -e -r -v 1 -d 2 -s 90MB -c 1000 -l /mnt/log/chkdb_hdd2.log
fi
/tmp/led_mp --STORAGE_BLINK 0

echo "========== Firmware Update End ==========" | tee -a /usr/share/fwrecovery/fwupgrade.log
/tmp/led_mp --ALLOFF
rm -rf /tmp/led_mp
reboot
exit 0

