function checkPort(instr)
{
  if (isNaN(instr.value))
  {
  	alert("Please enter number only.");
	instr.focus();
    instr.select();  	
  	return 0;
  }
  
  if( (instr.value < 1) || (instr.value>65535))
  {
  	alert("The range of port is from 1 to 65535");
	instr.focus();
    instr.select();  	
  	return 0;
  }	
  
  return 1;
}


function DisplayWarning(instr, warning)
{
	alert(warning);
	instr.focus();
    instr.select();
}

function IsValidIPAddress(instr){
	var warning = "Invalid IP: "+ instr.value;
	var sub;
	var iValue;
	var iCnt = 0;
	var temp = "";
	
	if(instr.value.charAt(0) == '.')
	{
		DisplayWarning(instr, warning);
		return 0;
	}
	
	for (i = 0; i < instr.value.length; i++){
        c = instr.value.charAt(i);
        if(!(c == '.' || ((c >= '0') && (c <= '9'))))
        {
          alert("Please enter number only.");
          instr.focus();
          instr.select();
          return 0;
        }
        
        if(c == '.')
        {
          iCnt++;
        }
    }
    
    if(iCnt != 3)
    {	
		DisplayWarning(instr, warning);
		return 0;
    }
    
    sub = instr.value.split(".", 4);    

	iValue = parseInt(sub[0]);
    if((sub[0].length < 1) || (iValue > 254) || (iValue < 1))
    {
		DisplayWarning(instr, warning);
		return 0;
   	}	
	
    if((sub[0].length < 1) || ((iValue <= 239) && (iValue >= 224)))
    {
		DisplayWarning(instr, warning);
		return 0;
   	}
   	
   	iValue = parseInt(sub[1]);
    if((sub[1].length < 1) || (iValue > 255) || (iValue < 0))
    {
		DisplayWarning(instr, warning);
		return 0;
   	}	
	iValue = parseInt(sub[2]);
    if((sub[2].length < 1) || (iValue > 255) || (iValue < 0))
    {
		DisplayWarning(instr, warning);
		return 0;
   	}	
   	
	iValue = parseInt(sub[3]);
    if((sub[3].length < 1) || (iValue > 254) || (iValue < 1))
    {
    	DisplayWarning(instr, warning);
		return 0;
   	}	
   return 1;
}

function checkMulticastRange(instr){
	var warning = "Invalid mulitcast address "+ instr.value;
	var sub;
	var iValue;
	var iCnt = 0;
	var temp = "";
	
	if(instr.value.charAt(0) == '.')
	{
		DisplayWarning(instr, warning);
		return 0;
	}
	for (i = 0; i < instr.value.length; i++){
        c = instr.value.charAt(i);
        if(!(c == '.' || ((c >= '0') && (c <= '9'))))
        {
          alert("Please enter number only.");
          instr.focus();
          instr.select();
          return 0;
        }
        
        if(c == '.')
        {
          iCnt++;
        }
    }
    
    if(iCnt != 3)
    {	
		DisplayWarning(instr, warning);
		return 0;
    }
    
    sub = instr.value.split(".", 4);    

	if((parseInt(sub[0]) == 224) && (parseInt(sub[1]) == 0) && (parseInt(sub[2]) == 0))
	{
		DisplayWarning(instr, warning);
		return 0;
	}
	
	iValue = parseInt(sub[0]);
	
    if((sub[0].length < 1) || (iValue > 239) || (iValue < 224))
    {
		DisplayWarning(instr, warning);
		return 0;
   	}
   	
   	iValue = parseInt(sub[1]);
    if((sub[1].length < 1) || (iValue > 255) || (iValue < 0))
    {
		DisplayWarning(instr, warning);
		return 0;
   	}	
	iValue = parseInt(sub[2]);
    if((sub[2].length < 1) || (iValue > 255) || (iValue < 0))
    {
		DisplayWarning(instr, warning);
		return 0;
   	}	
   	
	iValue = parseInt(sub[3]);
    if((sub[3].length < 1) || (iValue > 255) || (iValue < 0))
    {
    	DisplayWarning(instr, warning);
		return 0;
   	}	
   return 1;
}
